<?php

/**
 * @file
 * Post update functions for Permission Group module.
 */

use Drupal\Core\Config\Entity\ConfigEntityUpdater;
use Drupal\user\Entity\Role;

/**
 * Remove unnecessary dependencies on permission_group module.
 */
function permission_group_post_update_fix_dependencies(&$sandbox = NULL) {
  \Drupal::classResolver(ConfigEntityUpdater::class)->update($sandbox, 'user_role', function (Role $role) {
    $dependencies = $role->getDependencies();
    // Is there a dependency on the permission group module.
    if (isset($dependencies['module']) && in_array('permission_group', $dependencies['module'], TRUE)) {
      // Re-save the role if there are no linked groups.
      if (empty($role->getThirdPartySetting('permission_group', 'groups', []))) {
        $role->unsetThirdPartySetting('permission_group', 'groups');
        return TRUE;
      }
    }
    return FALSE;
  });
}
